// MakeOhio 2019 AEP Challenge
//Home Utility Usage Simulator

#include <SPI.h>

//define variable

String premiseID="OH12345678";
int hour = 5;
int minute = 30;

float tempOut=90;
float tempIn=68;
float kWh=2525;
float kW;
float GasCCF=5445;
float WatCCF=1458;
float Solar;

// Monitoring Events
bool Washer;
bool Dryer;
bool Dishwash;
bool Stove;
bool Refrig;
bool Furnace;
bool AC;
bool Sprinkler;

//Run Timers
int WasherTimer;
int DryerTimer;
int DishWashTimer;
int StoveTimer;
int RefrigTimer;
int SprinklerTimer;
int ShowerTimer;

//Non Monitored events
int Shower;       
int Flush=0;      //DI Initiated
int LargeLeak=0;  //DI Initiated
int SmallLeak=0;  //DI Initiated
int HairDryer=0;  //DI Initiated
int FloodLight=0;  //DI Initiated


void setup() {
  // Initialize Serial port
  
Serial.begin(9600);
  while (!Serial) continue;
delay(50);
Serial.println("MakeOhioAEP-Datagen-R0");
Serial.println();

pinMode (8, INPUT);  //Flush 
pinMode (9, INPUT);  //LargeLeak
pinMode (10, INPUT);  //SmallLeak
pinMode (11, INPUT);  //HairDryer
pinMode (12, INPUT);  //FloodLight
}

void loop() {

//Read Input Pins
Flush = digitalRead(8);
LargeLeak = digitalRead(9);
SmallLeak = digitalRead(10);
HairDryer = digitalRead(11);
FloodLight = digitalRead(12);
  
Serial.print (hour); Serial.print (":"); 
Serial.print (minute); Serial.print (", "); 

Serial.print (premiseID); Serial.print (", ");
Serial.print (tempOut); Serial.print (", ");
Serial.print (tempIn); Serial.print (", ");
Serial.print (kWh); Serial.print (", ");
Serial.print (kW,3); Serial.print (", ");
Serial.print (GasCCF); Serial.print (", ");
Serial.print (WatCCF); Serial.print (", ");
Serial.print (Solar,3); Serial.print (", ");

Serial.print (Washer); Serial.print (", ");
Serial.print (Dryer); Serial.print (", ");
Serial.print (Dishwash); Serial.print (", ");
Serial.print (Stove); Serial.print (", ");
Serial.print (Refrig); Serial.print (", ");
Serial.print (Furnace); Serial.print (", ");
Serial.print (AC); Serial.print (", ");
Serial.print (Sprinkler); Serial.print ("  ***  ");

Serial.print (Flush); Serial.print (" : ");
Serial.print (LargeLeak); Serial.print (" : ");
Serial.print (SmallLeak); Serial.print (" : ");
Serial.print (HairDryer); Serial.print (" : ");
Serial.print (FloodLight); Serial.println ();

//Home Model
  //Events
    //Washer
    if (hour==8&minute==30) Washer=1;
    if (Washer==1&WasherTimer<46) WasherTimer=WasherTimer+1;
      else {
        WasherTimer=0 ;
        Washer=0;
      }
       
    //Dryer
    if (hour==9&minute==30) Dryer=1;
    if (Dryer==1&DryerTimer<55) DryerTimer=DryerTimer+1;
      else {
        DryerTimer=0 ;
        Dryer=0;
      }
      
    //Dish Washer
    if (hour==9&minute==35) Dishwash=1;
    if (Dishwash==1&DishWashTimer<35) DishWashTimer=DishWashTimer+1;
      else {
        DishWashTimer=0 ;
        Dishwash=0;
      }
    
    //Stove
    if (hour==7&minute==45) Stove=1;
    if (Stove==1&StoveTimer<12) StoveTimer=StoveTimer+1;
      else {
        StoveTimer=0 ;
        Stove=0;
      }
      
    //Refrigerator:  5 minutes on per 18 minutes
    RefrigTimer = RefrigTimer+1;
    if (RefrigTimer>13) Refrig=1;
    if (RefrigTimer>18) {
      Refrig=0;
      RefrigTimer=0;
    }

    //Shower    Note: There is no appliance flag.  This is an unmonitored water use
    if (hour==7&minute==15) Shower=1;
    if (Shower==1&ShowerTimer<11) ShowerTimer=ShowerTimer+1;
      else {
        ShowerTimer=0 ;
        Shower=0;
      }

    //Sprinkler
    if (tempOut>80&hour==6&minute==30) Sprinkler=1;
    if (Sprinkler==1&SprinklerTimer<31) SprinklerTimer=SprinklerTimer+1;
      else {
        SprinklerTimer=0 ;
        Sprinkler=0;
      }
    //Solar Intensity (0 to 1)
    if (hour>=6&hour<18) {
      float HourF=hour;
      float MinuteF=minute;
      float TimeF=HourF+MinuteF/60;
      Solar = sin((TimeF-6)/12*3.14);
    }
    else Solar=0;

    //Furnace and AC Control
    float deltaT=tempOut-tempIn;
    tempIn=tempIn+(deltaT*.002)+(Solar*.001)+(Furnace*.5)-(AC*.3); //heat loss of home
    if (tempIn<66) Furnace=1; //Thermostat On-Furnace
    if (tempIn>70) Furnace = 0; //Thermostat Off-Furnace
    if (tempIn>76) AC=1; //Thermostat ON-AC
    if (tempIn<73) AC=0; //Thermostat Off-AC
    
  //Utility Consumption
  float Watts=185+random(0,150)+Washer*800+Dryer*3500+Dishwash*600+Stove*1500+Refrig*150+Furnace*120+AC*4500+HairDryer*2900+FloodLight*600;
  kW = Watts/1000;
  kWh=kWh+kW/60;
  GasCCF=GasCCF+Furnace*4.2/100;
  WatCCF=WatCCF+Washer*.2+Dishwash*.1+Shower*0.9+Sprinkler*2.5+LargeLeak*10+SmallLeak*0.1;

//Increment Time
minute=minute+1;
if (minute>59) {
  hour = hour + 1;
  minute = 0;
if (hour > 23) hour =0;
}
//Home Monitoring, Display and Diagnostics Section
//Put stuff here
//Put stuff here
//Put stuff here, etc.
//74% of the program storage space is available for an arduino UNO.

delay(500);  //Loop Delay
}
